#line 1 "C:/Users/uemin/Desktop/GitHub/Trudyo/Program/Web Apps/28BYJ-48 Step Motor 01/main.c"
#line 1 "c:/users/uemin/desktop/github/trudyo/program/web apps/28byj-48 step motor 01/library/step.c"

const unsigned short FULL_STEP_MODE=0;
const unsigned short HALF_STEP_MODE=1;


unsigned short stepFull[]={0b00001000,0b00000100,0b00000010,0b00000001};
unsigned short stepHalf[]={0b00001100,0b00000110,0b00000011,0b00001001};

unsigned short stepTimer=0;

void step_delay_10us(unsigned long time){
 while(time--)
 Delay_10us();
}

signed short stepIndex=0;
unsigned int currentLocation=0;

void StepMotorListener(unsigned int location, unsigned long time){
 time/=50;
 stepTimer++;
 if(stepTimer>time){
 stepTimer=0;
 if(currentLocation<location){
 currentLocation++;
  LATD7_bit =stepFull[currentLocation%4].B0;
  LATD6_bit =stepFull[currentLocation%4].B1;
  LATD5_bit =stepFull[currentLocation%4].B2;
  LATD4_bit =stepFull[currentLocation%4].B3;
 }
 else if(currentLocation>location){
 currentLocation--;
  LATD7_bit =stepFull[currentLocation%4].B0;
  LATD6_bit =stepFull[currentLocation%4].B1;
  LATD5_bit =stepFull[currentLocation%4].B2;
  LATD4_bit =stepFull[currentLocation%4].B3;
 }
 else{
  LATD7_bit =0;
  LATD6_bit =0;
  LATD5_bit =0;
  LATD4_bit =0;
 }
 }
}

void SetStepMotor(signed int step, unsigned short mode, unsigned long time){
 time/=20;
 while(step<0 || step>0){
  LATD7_bit =stepFull[stepIndex].B0;
  LATD6_bit =stepFull[stepIndex].B1;
  LATD5_bit =stepFull[stepIndex].B2;
  LATD4_bit =stepFull[stepIndex].B3;

 step_delay_10us(time);

 if(mode==HALF_STEP_MODE){
  LATD7_bit =stepHalf[stepIndex].B0;
  LATD6_bit =stepHalf[stepIndex].B1;
  LATD5_bit =stepHalf[stepIndex].B2;
  LATD4_bit =stepHalf[stepIndex].B3;
 }
 else{
  LATD7_bit =stepFull[stepIndex].B0;
  LATD6_bit =stepFull[stepIndex].B1;
  LATD5_bit =stepFull[stepIndex].B2;
  LATD4_bit =stepFull[stepIndex].B3;
 }

 step_delay_10us(time);


 if(step>0){
 stepIndex++;
 step--;
 if(stepIndex>3)
 stepIndex=0;
 }
 else if(step<0){
 stepIndex--;
 step++;
 if(stepIndex<0)
 stepIndex=3;
 }
 }

  LATD7_bit =0;
  LATD6_bit =0;
  LATD5_bit =0;
  LATD4_bit =0;
}
#line 7 "C:/Users/uemin/Desktop/GitHub/Trudyo/Program/Web Apps/28BYJ-48 Step Motor 01/main.c"
void main() {

 TRISA=0b00000000;
 TRISB=0b00000000;
 TRISC=0b00000000;
 TRISD=0b00000000;
 TRISE=0b00000000;


 ANSELA=0b00000000;
 ANSELB=0b00000000;
 ANSELC=0b00000000;
 ANSELD=0b00000000;
 ANSELE=0b00000000;


 LATA=0x00;
 LATB=0x00;
 LATC=0x00;
 LATD=0x00;
 LATE=0x00;

 SetStepMotor(2048, HALF_STEP_MODE, 3000);
 SetStepMotor(-2048, FULL_STEP_MODE, 3000);
 SetStepMotor(512, HALF_STEP_MODE, 3000);
 SetStepMotor(-512, HALF_STEP_MODE, 3000);


 while(1){
 SetStepMotor(20, HALF_STEP_MODE, 1000000);
 SetStepMotor(20, FULL_STEP_MODE, 1000000);
 }
}
