// Step Motor Baglantilari
#define STEP_IN1 LATD7_bit
#define STEP_IN2 LATD6_bit
#define STEP_IN3 LATD5_bit
#define STEP_IN4 LATD4_bit
#include "Library/STEP.c"

void main() {
  // Port Giris-ikis Seimi (0:ikis, 1:Giris)
  TRISA=0b00000000; // [][][][LED][][][][]
  TRISB=0b00000000; // [][][][][][][][]
  TRISC=0b00000000; // [][][][][][][][]
  TRISD=0b00000000; // [STEP_IN1][STEP_IN2][STEP_IN3][STEP_IN4][][][][]
  TRISE=0b00000000; // [][][][][][][][]

  // Port Analog-Dijital Giris Seimi (0:Dijital, 1:Analog)
  ANSELA=0b00000000; // [][][][][][][][]
  ANSELB=0b00000000; // [][][][][][][][]
  ANSELC=0b00000000; // [][][][][][][][]
  ANSELD=0b00000000; // [][][][][][][][]
  ANSELE=0b00000000; // [][][][][][][][]

  // Port Temizleme
  LATA=0x00;
  LATB=0x00;
  LATC=0x00;
  LATD=0x00;
  LATE=0x00;

  SetStepMotor(2048, HALF_STEP_MODE, 3000);     // Yarim adim modunda 3000us bekleme ile 2048 adim ileri dn (fonksiyon icerisinde her bir adim iin iki adimlik hareket yapiliyor)
  SetStepMotor(-2048, FULL_STEP_MODE, 3000);    // Tam adim modunda 3000us bekleme ile 2048 adim geri dn
  SetStepMotor(512, HALF_STEP_MODE, 3000);      // Yarim adim modunda 3000us bekleme ile 512 adim ileri dn
  SetStepMotor(-512, HALF_STEP_MODE, 3000);     // Tam adim modunda 3000us bekleme ile 512 adim geri dn

  // Sonsuz Dongu
  while(1){
    SetStepMotor(20, HALF_STEP_MODE, 1000000);  // Yarim adim modunda 1s bekleme ile 20 adim ileri dn
    SetStepMotor(20, FULL_STEP_MODE, 1000000);  // Tam adim modunda 1s bekleme ile 20 adim geri dn
  }
}